#include <iostream>
#include <cmath>
using namespace std;

int main()
{
	// the nine cells; 0: empty, 1: player 1, -1: player 2
	// 1 for left-top, 2 for center-top, 3 for right-top, 4 for left-middle, ...
	int cellsOccupied = 0;
		
	while (cin >> cellsOccupied)
	{
		// the cells
		int cell[3][3];
		for (int i = 0; i < 3; i++)
		{
			for (int j = 0; j < 3; j++)
				cell[i][j] = 0;
		}
		
		// set up the partial game; 0: empty, 1: player 1, -1: player 2
		int occupied = 0;
		for (int i = 0; i < cellsOccupied; i++)
		{
			cin >> occupied;
			cell[(occupied - 1) / 3][(occupied - 1) % 3] = static_cast<int>(pow(-1, i)); 
		}
				
		// the number of winning cells
		int winningCell = 0;
		int cellOfPlayer1 = 0;
		
		// also need to record who are winning cells
		bool winning[3][3] = {false};
		
		// the three rows
		for (int i = 0; i < 3; i++)
		{
			cellOfPlayer1 = 0;
			
			for (int j = 0; j < 3; j++)
				cellOfPlayer1 += cell[i][j];
			
			if (cellOfPlayer1 == 2)
			{
				// determine who is the winning cell
				for (int j = 0; j < 3; j++)
				{
					if (cell[i][j] == 0 && winning[i][j] == false) 
					{
						// the winning cell has not been discovered
						winning[i][j] = true;
						winningCell++;
					}
				}				
			}
		}

		// the three columns		
		for (int i = 0; i < 3; i++)
		{
			cellOfPlayer1 = 0;
			
			for (int j = 0; j < 3; j++)
				cellOfPlayer1 += cell[j][i];
			
			if (cellOfPlayer1 == 2)
			{
				// determine who is the winning cell
				for (int j = 0; j < 3; j++)
				{
					if (cell[j][i] == 0 && winning[j][i] == false) 
					{
						// the winning cell has not been discovered
						winning[j][i] = true;
						winningCell++;
					}
				}				
			}
		}
		
		// the two diagonals
		cellOfPlayer1 = 0;
		for (int i = 0; i < 3; i++)
		{
			cellOfPlayer1 += cell[i][i];
		}
		if (cellOfPlayer1 == 2)
		{
			// determine who is the winning cell
			for (int i = 0; i < 3; i++)
			{
				if (cell[i][i] == 0 && winning[i][i] == false) 
				{
					// the winning cell has not been discovered
					winning[i][i] = true;
					winningCell++;
				}
			}				
		}
			
		cellOfPlayer1 = 0;
		for (int i = 0; i < 3; i++)
		{
			cellOfPlayer1 += cell[2 - i][i];
		}
		if (cellOfPlayer1 == 2)
		{
			// determine who is the winning cell
			for (int i = 0; i < 3; i++)
			{
				if (cell[2 - i][i] == 0 && winning[2 - i][i] == false) 
				{
					// the winning cell has not been discovered
					winning[2 - i][i] = true;
					winningCell++;
				}
			}				
		}
				
		// output
		cout << winningCell << endl;
	}
	
	return 0;
}
